Package net.sf.saxon.expr

## Class FilterIterator

- java.lang.Object
- - net.sf.saxon.expr.FilterIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `SequenceIterator`
  Direct Known Subclasses:
    `FilterIterator.NonNumeric`

      public class FilterIterator
      extends java.lang.Object
      implements SequenceIterator

  A FilterIterator filters an input sequence using a filter expression. Note that a FilterIterator is not used where the filter is a constant number (PositionFilter is used for this purpose instead), so this class does no optimizations for numeric predicates.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `FilterIterator.NonNumeric` | Subclass to handle the common special case where it is statically known that the filter cannot return a numeric value

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected FocusIterator` | `base` |
    `protected Expression` | `filter` |
    `protected XPathContext` | `filterContext` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FilterIterator​(SequenceIterator base, Expression filter, XPathContext context)` | Constructor

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `protected Item` | `getNextMatchingItem()` | Get the next item in the base sequence that matches the filter predicate if there is such an item, or null if not.
    `protected boolean` | `matches()` | Determine whether the context item matches the filter predicate
    `Item` | `next()` | Get the next item if there is one
    `void` | `setSequence​(SequenceIterator base, XPathContext context)` | Set the base iterator
    `static boolean` | `testPredicateValue​(SequenceIterator iterator, long position, Expression filter)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, getProperties, materialize`

- - ### Field Detail

    - #### base

          protected FocusIterator base

    - #### filter

          protected Expression filter

    - #### filterContext

          protected XPathContext filterContext

  - ### Constructor Detail

    - #### FilterIterator

          public FilterIterator​(SequenceIterator base,
                                Expression filter,
                                XPathContext context)

      Constructor
      Parameters:
        `base` - An iteration of the items to be filtered
        `filter` - The expression defining the filter predicate
        `context` - The context in which the expression is being evaluated

  - ### Method Detail

    - #### setSequence

          public void setSequence​(SequenceIterator base,
                                  XPathContext context)

      Set the base iterator
      Parameters:
        `base` - the iterator over the sequence to be filtered
        `context` - the context in which the (outer) filter expression is evaluated

    - #### next

          public Item next()
                    throws XPathException

      Get the next item if there is one
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### getNextMatchingItem

          protected Item getNextMatchingItem()
                                      throws XPathException

      Get the next item in the base sequence that matches the filter predicate if there is such an item, or null if not.
      Returns:
        the next item that matches the predicate
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### matches

          protected boolean matches()
                             throws XPathException

      Determine whether the context item matches the filter predicate
      Returns:
        true if the context item matches
      Throws:
        `XPathException` - if an error occurs evaluating the match

    - #### testPredicateValue

          public static boolean testPredicateValue​(SequenceIterator iterator,
                                                   long position,
                                                   Expression filter)
                                            throws XPathException

      Throws:
        `XPathException`

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`